/* tslint:disable */
/* eslint-disable */
/**
*/
export function resetChat(): void;
/**
* @param {IGenerateInput} input
* @returns {Promise<void>}
*/
export function chat(input: IGenerateInput): Promise<void>;
/**
* @returns {Promise<void>}
*/
export function signIn(): Promise<void>;
/**
*/
export function signOut(): void;
/**
* @param {string} prompt
* @param {IProjectHandler} handler
* @returns {Promise<any>}
*/
export function generateProject(prompt: string, handler: IProjectHandler): Promise<any>;
/**
* @param {IGenerateInput} input
* @returns {Promise<void>}
*/
export function generateCode(input: IGenerateInput): Promise<void>;
/**
* @param {IExtensionContext} context
*/
export function setExtensionContext(context: IExtensionContext): void;
/**
*/
export enum RustProgressLocation {
  SourceControl = 1,
/**
*
*     * Show progress in the status bar of the editor. Neither supports cancellation nor discrete progress.
*     * Supports rendering of {@link ThemeIcon theme icons} via the `$(<name>)`-syntax in the progress label.
*     
*/
  Window = 10,
/**
*
*     * Show progress as notification with an optional cancel button. Supports to show infinite and discrete
*     * progress but does not support rendering of icons.
*     
*/
  Notification = 15,
}

interface IProgress {
    report(message?: string): void;
}



interface IGlobalStorage {
    update(key: string, value: string | undefined): void;
    get(key: string): string | null;
}



interface IProjectHandler {
    async createFileRecursive(path: string): void;
    makeFileWriter(path: string): IProjectFileWriter | undefined;
}



interface IProjectFileWriter {
    write(contents: string): void;
    end(): void;
}



interface ISelectionRange {
    get offset(): number;
    get length(): number;
}



interface IResultStream {
    write(contents: string): void;
    end(): void;
}



interface IGenerateInput {
    get prompt(): string;
    get msgType(): string;    
    get documentText(): string;
    get filePath(): string;
    get workspaceDirectory(): string | null;
    get selectionRange(): ISelectionRange;
    get resultStream(): IResultStream;
    get abortSignal(): AbortSignal;
    get apiKey(): string | null;
    get gptModel(): string | null;
}



interface IExtensionContext {
    get storage(): IGlobalStorage;
    executeCommand(command: string, ...args: any[]): Thenable<any>;
    withProgress(options: RustProgressOptions, callback: () => Thenable<any>): Thenable<any>;
    showInformationMessage(message: string, items: string[]): Thenable<string | undefined>;
}


/**
*/
export class RustProgressOptions {
  free(): void;
/**
*/
  cancellable: boolean;
/**
*/
  location: number;
/**
*/
  title?: string;
}
