let imports = {};
imports['__wbindgen_placeholder__'] = module.exports;
let wasm;
const { request } = require(`node:https`);
const { TextDecoder, TextEncoder } = require(`util`);

let cachedTextDecoder = new TextDecoder('utf-8', { ignoreBOM: true, fatal: true });

cachedTextDecoder.decode();

let cachedUint8Memory0 = null;

function getUint8Memory0() {
    if (cachedUint8Memory0 === null || cachedUint8Memory0.byteLength === 0) {
        cachedUint8Memory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachedUint8Memory0;
}

function getStringFromWasm0(ptr, len) {
    return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
}

const heap = new Array(128).fill(undefined);

heap.push(undefined, null, true, false);

let heap_next = heap.length;

function addHeapObject(obj) {
    if (heap_next === heap.length) heap.push(heap.length + 1);
    const idx = heap_next;
    heap_next = heap[idx];

    if (typeof(heap_next) !== 'number') throw new Error('corrupt heap');

    heap[idx] = obj;
    return idx;
}

function getObject(idx) { return heap[idx]; }

let WASM_VECTOR_LEN = 0;

let cachedTextEncoder = new TextEncoder('utf-8');

const encodeString = (typeof cachedTextEncoder.encodeInto === 'function'
    ? function (arg, view) {
    return cachedTextEncoder.encodeInto(arg, view);
}
    : function (arg, view) {
    const buf = cachedTextEncoder.encode(arg);
    view.set(buf);
    return {
        read: arg.length,
        written: buf.length
    };
});

function passStringToWasm0(arg, malloc, realloc) {

    if (typeof(arg) !== 'string') throw new Error('expected a string argument');

    if (realloc === undefined) {
        const buf = cachedTextEncoder.encode(arg);
        const ptr = malloc(buf.length);
        getUint8Memory0().subarray(ptr, ptr + buf.length).set(buf);
        WASM_VECTOR_LEN = buf.length;
        return ptr;
    }

    let len = arg.length;
    let ptr = malloc(len);

    const mem = getUint8Memory0();

    let offset = 0;

    for (; offset < len; offset++) {
        const code = arg.charCodeAt(offset);
        if (code > 0x7F) break;
        mem[ptr + offset] = code;
    }

    if (offset !== len) {
        if (offset !== 0) {
            arg = arg.slice(offset);
        }
        ptr = realloc(ptr, len, len = offset + arg.length * 3);
        const view = getUint8Memory0().subarray(ptr + offset, ptr + len);
        const ret = encodeString(arg, view);
        if (ret.read !== arg.length) throw new Error('failed to pass whole string');
        offset += ret.written;
    }

    WASM_VECTOR_LEN = offset;
    return ptr;
}

function isLikeNone(x) {
    return x === undefined || x === null;
}

let cachedInt32Memory0 = null;

function getInt32Memory0() {
    if (cachedInt32Memory0 === null || cachedInt32Memory0.byteLength === 0) {
        cachedInt32Memory0 = new Int32Array(wasm.memory.buffer);
    }
    return cachedInt32Memory0;
}

function _assertBoolean(n) {
    if (typeof(n) !== 'boolean') {
        throw new Error('expected a boolean argument');
    }
}

function dropObject(idx) {
    if (idx < 132) return;
    heap[idx] = heap_next;
    heap_next = idx;
}

function takeObject(idx) {
    const ret = getObject(idx);
    dropObject(idx);
    return ret;
}

function debugString(val) {
    // primitive types
    const type = typeof val;
    if (type == 'number' || type == 'boolean' || val == null) {
        return  `${val}`;
    }
    if (type == 'string') {
        return `"${val}"`;
    }
    if (type == 'symbol') {
        const description = val.description;
        if (description == null) {
            return 'Symbol';
        } else {
            return `Symbol(${description})`;
        }
    }
    if (type == 'function') {
        const name = val.name;
        if (typeof name == 'string' && name.length > 0) {
            return `Function(${name})`;
        } else {
            return 'Function';
        }
    }
    // objects
    if (Array.isArray(val)) {
        const length = val.length;
        let debug = '[';
        if (length > 0) {
            debug += debugString(val[0]);
        }
        for(let i = 1; i < length; i++) {
            debug += ', ' + debugString(val[i]);
        }
        debug += ']';
        return debug;
    }
    // Test for built-in
    const builtInMatches = /\[object ([^\]]+)\]/.exec(toString.call(val));
    let className;
    if (builtInMatches.length > 1) {
        className = builtInMatches[1];
    } else {
        // Failed to match the standard '[object ClassName]'
        return toString.call(val);
    }
    if (className == 'Object') {
        // we're a user defined class or Object
        // JSON.stringify avoids problems with cycles, and is generally much
        // easier than looping through ownProperties of `val`.
        try {
            return 'Object(' + JSON.stringify(val) + ')';
        } catch (_) {
            return 'Object';
        }
    }
    // errors
    if (val instanceof Error) {
        return `${val.name}: ${val.message}\n${val.stack}`;
    }
    // TODO we could test for more things here, like `Set`s and `Map`s.
    return className;
}

const CLOSURE_DTORS = new FinalizationRegistry(state => {
    wasm.__wbindgen_export_2.get(state.dtor)(state.a, state.b)
});

function makeMutClosure(arg0, arg1, dtor, f) {
    const state = { a: arg0, b: arg1, cnt: 1, dtor };
    const real = (...args) => {
        // First up with a closure we increment the internal reference
        // count. This ensures that the Rust closure environment won't
        // be deallocated while we're invoking it.
        state.cnt++;
        const a = state.a;
        state.a = 0;
        try {
            return f(a, state.b, ...args);
        } finally {
            if (--state.cnt === 0) {
                wasm.__wbindgen_export_2.get(state.dtor)(a, state.b);
                CLOSURE_DTORS.unregister(state)
            } else {
                state.a = a;
            }
        }
    };
    real.original = state;
    CLOSURE_DTORS.register(real, state, state);
    return real;
}

function logError(f, args) {
    try {
        return f.apply(this, args);
    } catch (e) {
        let error = (function () {
            try {
                return e instanceof Error ? `${e.message}\n\nStack:\n${e.stack}` : e.toString();
            } catch(_) {
                return "<failed to stringify thrown value>";
            }
        }());
        console.error("wasm-bindgen: imported JS function that was not marked as `catch` threw an error:", error);
        throw e;
    }
}

function _assertNum(n) {
    if (typeof(n) !== 'number') throw new Error('expected a number argument');
}
function __wbg_adapter_28(arg0, arg1, arg2) {
    _assertNum(arg0);
    _assertNum(arg1);
    wasm._dyn_core__ops__function__FnMut__A____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h2a706655af4660c8(arg0, arg1, addHeapObject(arg2));
}

function __wbg_adapter_31(arg0, arg1, arg2, arg3) {
    _assertNum(arg0);
    _assertNum(arg1);
    const ret = wasm._dyn_core__ops__function__FnMut__A_B___Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__hba2b8a9f3eb8177a(arg0, arg1, addHeapObject(arg2), addHeapObject(arg3));
    return takeObject(ret);
}

function __wbg_adapter_34(arg0, arg1) {
    _assertNum(arg0);
    _assertNum(arg1);
    wasm._dyn_core__ops__function__FnMut_____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h525a45fa6e4ea18d(arg0, arg1);
}

function __wbg_adapter_37(arg0, arg1, arg2) {
    _assertNum(arg0);
    _assertNum(arg1);
    wasm._dyn_core__ops__function__FnMut__A____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h3ee0eb1d24e5144e(arg0, arg1, addHeapObject(arg2));
}

function __wbg_adapter_40(arg0, arg1) {
    _assertNum(arg0);
    _assertNum(arg1);
    wasm._dyn_core__ops__function__FnMut_____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h85caf7259b51848d(arg0, arg1);
}

function __wbg_adapter_43(arg0, arg1, arg2) {
    _assertNum(arg0);
    _assertNum(arg1);
    wasm._dyn_core__ops__function__FnMut__A____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h91bf4f55048a24fa(arg0, arg1, addHeapObject(arg2));
}

/**
*/
module.exports.resetChat = function() {
    wasm.resetChat();
};

/**
* @param {IGenerateInput} input
* @returns {Promise<void>}
*/
module.exports.chat = function(input) {
    const ret = wasm.chat(addHeapObject(input));
    return takeObject(ret);
};

/**
* @returns {Promise<void>}
*/
module.exports.signIn = function() {
    const ret = wasm.signIn();
    return takeObject(ret);
};

/**
*/
module.exports.signOut = function() {
    wasm.signOut();
};

/**
* @param {string} prompt
* @param {IProjectHandler} handler
* @returns {Promise<any>}
*/
module.exports.generateProject = function(prompt, handler) {
    const ptr0 = passStringToWasm0(prompt, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.generateProject(ptr0, len0, addHeapObject(handler));
    return takeObject(ret);
};

/**
* @param {IGenerateInput} input
* @returns {Promise<void>}
*/
module.exports.generateCode = function(input) {
    const ret = wasm.generateCode(addHeapObject(input));
    return takeObject(ret);
};

/**
* @param {IExtensionContext} context
*/
module.exports.setExtensionContext = function(context) {
    wasm.setExtensionContext(addHeapObject(context));
};

function handleError(f, args) {
    try {
        return f.apply(this, args);
    } catch (e) {
        wasm.__wbindgen_exn_store(addHeapObject(e));
    }
}

function getArrayU8FromWasm0(ptr, len) {
    return getUint8Memory0().subarray(ptr / 1, ptr / 1 + len);
}
function __wbg_adapter_169(arg0, arg1, arg2, arg3) {
    _assertNum(arg0);
    _assertNum(arg1);
    wasm.wasm_bindgen__convert__closures__invoke2_mut__hffe91779bc4629ff(arg0, arg1, addHeapObject(arg2), addHeapObject(arg3));
}

/**
*/
module.exports.RustProgressLocation = Object.freeze({ SourceControl:1,"1":"SourceControl",
/**
*
*     * Show progress in the status bar of the editor. Neither supports cancellation nor discrete progress.
*     * Supports rendering of {@link ThemeIcon theme icons} via the `$(<name>)`-syntax in the progress label.
*
*/
Window:10,"10":"Window",
/**
*
*     * Show progress as notification with an optional cancel button. Supports to show infinite and discrete
*     * progress but does not support rendering of icons.
*
*/
Notification:15,"15":"Notification", });

const RustProgressOptionsFinalization = new FinalizationRegistry(ptr => wasm.__wbg_rustprogressoptions_free(ptr));
/**
*/
class RustProgressOptions {

    constructor() {
        throw new Error('cannot invoke `new` directly');
    }

    static __wrap(ptr) {
        const obj = Object.create(RustProgressOptions.prototype);
        obj.ptr = ptr;
        RustProgressOptionsFinalization.register(obj, obj.ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;
        RustProgressOptionsFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_rustprogressoptions_free(ptr);
    }
    /**
    * @returns {number}
    */
    get location() {
        if (this.ptr == 0) throw new Error('Attempt to use a moved value');
        _assertNum(this.ptr);
        const ret = wasm.__wbg_get_rustprogressoptions_location(this.ptr);
        return ret >>> 0;
    }
    /**
    * @param {number} arg0
    */
    set location(arg0) {
        if (this.ptr == 0) throw new Error('Attempt to use a moved value');
        _assertNum(this.ptr);
        _assertNum(arg0);
        wasm.__wbg_set_rustprogressoptions_location(this.ptr, arg0);
    }
    /**
    * @returns {string | undefined}
    */
    get title() {
        try {
            if (this.ptr == 0) throw new Error('Attempt to use a moved value');
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            _assertNum(this.ptr);
            wasm.__wbg_get_rustprogressoptions_title(retptr, this.ptr);
            var r0 = getInt32Memory0()[retptr / 4 + 0];
            var r1 = getInt32Memory0()[retptr / 4 + 1];
            let v0;
            if (r0 !== 0) {
                v0 = getStringFromWasm0(r0, r1).slice();
                wasm.__wbindgen_free(r0, r1 * 1);
            }
            return v0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {string | undefined} arg0
    */
    set title(arg0) {
        if (this.ptr == 0) throw new Error('Attempt to use a moved value');
        _assertNum(this.ptr);
        var ptr0 = isLikeNone(arg0) ? 0 : passStringToWasm0(arg0, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len0 = WASM_VECTOR_LEN;
        wasm.__wbg_set_rustprogressoptions_title(this.ptr, ptr0, len0);
    }
    /**
    * @returns {boolean}
    */
    get cancellable() {
        if (this.ptr == 0) throw new Error('Attempt to use a moved value');
        _assertNum(this.ptr);
        const ret = wasm.__wbg_get_rustprogressoptions_cancellable(this.ptr);
        return ret !== 0;
    }
    /**
    * @param {boolean} arg0
    */
    set cancellable(arg0) {
        if (this.ptr == 0) throw new Error('Attempt to use a moved value');
        _assertNum(this.ptr);
        _assertBoolean(arg0);
        wasm.__wbg_set_rustprogressoptions_cancellable(this.ptr, arg0);
    }
}
module.exports.RustProgressOptions = RustProgressOptions;

module.exports.__wbg_createFileRecursive_ecec4c28e8a0cd55 = function() { return logError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).createFileRecursive(getStringFromWasm0(arg1, arg2));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_report_b1350e38fbfbb9ef = function() { return logError(function (arg0, arg1, arg2) {
    getObject(arg0).report(getStringFromWasm0(arg1, arg2));
}, arguments) };

module.exports.__wbg_update_78995a347b35d3fe = function() { return logError(function (arg0, arg1, arg2, arg3, arg4) {
    getObject(arg0).update(getStringFromWasm0(arg1, arg2), arg3 === 0 ? undefined : getStringFromWasm0(arg3, arg4));
}, arguments) };

module.exports.__wbg_get_12979c18f65fa387 = function() { return logError(function (arg0, arg1, arg2, arg3) {
    const ret = getObject(arg1).get(getStringFromWasm0(arg2, arg3));
    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbindgen_error_new = function(arg0, arg1) {
    const ret = new Error(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
};

module.exports.__wbindgen_string_new = function(arg0, arg1) {
    const ret = getStringFromWasm0(arg0, arg1);
    return addHeapObject(ret);
};

module.exports.__wbindgen_string_get = function(arg0, arg1) {
    const obj = getObject(arg1);
    const ret = typeof(obj) === 'string' ? obj : undefined;
    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

module.exports.__wbindgen_object_clone_ref = function(arg0) {
    const ret = getObject(arg0);
    return addHeapObject(ret);
};

module.exports.__wbg_executeCommand_8e72a0555abfd01c = function() { return logError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).executeCommand(getStringFromWasm0(arg1, arg2));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_executeCommand_ce657a3de945bf8c = function() { return logError(function (arg0, arg1, arg2, arg3) {
    const ret = getObject(arg0).executeCommand(getStringFromWasm0(arg1, arg2), takeObject(arg3));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_withProgress_385e405857425a8d = function() { return logError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).withProgress(RustProgressOptions.__wrap(arg1), takeObject(arg2));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_showInformationMessage_893cde3657767c82 = function() { return logError(function (arg0, arg1, arg2, arg3) {
    const ret = getObject(arg0).showInformationMessage(getStringFromWasm0(arg1, arg2), takeObject(arg3));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_makeFileWriter_9760df5eef93505f = function() { return logError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).makeFileWriter(getStringFromWasm0(arg1, arg2));
    return isLikeNone(ret) ? 0 : addHeapObject(ret);
}, arguments) };

module.exports.__wbg_write_18c504c1703ad113 = function() { return logError(function (arg0, arg1, arg2) {
    getObject(arg0).write(getStringFromWasm0(arg1, arg2));
}, arguments) };

module.exports.__wbg_end_5b6bccf216137a3b = function() { return logError(function (arg0) {
    getObject(arg0).end();
}, arguments) };

module.exports.__wbg_offset_9dc8f9328a0ca77d = function() { return logError(function (arg0) {
    const ret = getObject(arg0).offset;
    _assertNum(ret);
    return ret;
}, arguments) };

module.exports.__wbg_length_19d5cdfa0911079f = function() { return logError(function (arg0) {
    const ret = getObject(arg0).length;
    _assertNum(ret);
    return ret;
}, arguments) };

module.exports.__wbg_write_9bf50c672ec16587 = function() { return logError(function (arg0, arg1, arg2) {
    getObject(arg0).write(getStringFromWasm0(arg1, arg2));
}, arguments) };

module.exports.__wbg_end_e83823994601dfb0 = function() { return logError(function (arg0) {
    getObject(arg0).end();
}, arguments) };

module.exports.__wbg_prompt_d4fad4c9bdc71adf = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg1).prompt;
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbg_msgType_5517200837a08a17 = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg1).msgType;
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbg_documentText_8b706bec670c17c7 = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg1).documentText;
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbg_filePath_15e221387d2f12db = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg1).filePath;
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbg_workspaceDirectory_43b291788943a9f3 = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg1).workspaceDirectory;
    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbg_selectionRange_52aaf27a2dfd0547 = function() { return logError(function (arg0) {
    const ret = getObject(arg0).selectionRange;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_resultStream_01013090e2deda57 = function() { return logError(function (arg0) {
    const ret = getObject(arg0).resultStream;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_abortSignal_4265a811cdd3dccd = function() { return logError(function (arg0) {
    const ret = getObject(arg0).abortSignal;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_apiKey_28960f3120450ff8 = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg1).apiKey;
    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbg_gptModel_04504b4041cd3a03 = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg1).gptModel;
    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbg_storage_17bbe37afdef44b2 = function() { return logError(function (arg0) {
    const ret = getObject(arg0).storage;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbindgen_is_object = function(arg0) {
    const val = getObject(arg0);
    const ret = typeof(val) === 'object' && val !== null;
    _assertBoolean(ret);
    return ret;
};

module.exports.__wbindgen_is_string = function(arg0) {
    const ret = typeof(getObject(arg0)) === 'string';
    _assertBoolean(ret);
    return ret;
};

module.exports.__wbg_crypto_e1d53a1d73fb10b8 = function() { return logError(function (arg0) {
    const ret = getObject(arg0).crypto;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_msCrypto_6e7d3e1f92610cbb = function() { return logError(function (arg0) {
    const ret = getObject(arg0).msCrypto;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_getRandomValues_805f1c3d65988a5a = function() { return handleError(function (arg0, arg1) {
    getObject(arg0).getRandomValues(getObject(arg1));
}, arguments) };

module.exports.__wbg_randomFillSync_6894564c2c334c42 = function() { return handleError(function (arg0, arg1, arg2) {
    getObject(arg0).randomFillSync(getArrayU8FromWasm0(arg1, arg2));
}, arguments) };

module.exports.__wbg_require_78a3dcfbdba9cbce = function() { return handleError(function () {
    const ret = module.require;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_process_038c26bf42b093f8 = function() { return logError(function (arg0) {
    const ret = getObject(arg0).process;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_versions_ab37218d2f0b24a8 = function() { return logError(function (arg0) {
    const ret = getObject(arg0).versions;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_node_080f4b19d15bc1fe = function() { return logError(function (arg0) {
    const ret = getObject(arg0).node;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_log_0a16b781f2df1c67 = function() { return logError(function (arg0, arg1) {
    console.log(getStringFromWasm0(arg0, arg1));
}, arguments) };

module.exports.__wbg_log_5eb34143018880ed = function() { return logError(function (arg0, arg1) {
    console.log(getObject(arg0), getObject(arg1));
}, arguments) };

module.exports.__wbg_error_2134f74d0a31295d = function() { return logError(function (arg0) {
    console.error(getObject(arg0));
}, arguments) };

module.exports.__wbg_addEventListener_a535ad63eab3b20e = function() { return logError(function (arg0, arg1, arg2, arg3) {
    getObject(arg0).addEventListener(getStringFromWasm0(arg1, arg2), takeObject(arg3));
}, arguments) };

module.exports.__wbg_from_bb0ee6d6106307fb = function() { return logError(function (arg0, arg1, arg2, arg3) {
    const ret = Buffer.from(getStringFromWasm0(arg0, arg1), getStringFromWasm0(arg2, arg3));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_toString_087f2d6ca30cc57c = function() { return logError(function (arg0, arg1, arg2, arg3) {
    const ret = getObject(arg1).toString(getStringFromWasm0(arg2, arg3));
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
}, arguments) };

module.exports.__wbg_request_fce2df08adb578dd = function() { return logError(function (arg0, arg1, arg2) {
    const ret = request(getStringFromWasm0(arg0, arg1), takeObject(arg2));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_write_b7aa907e26e96192 = function() { return logError(function (arg0, arg1) {
    getObject(arg0).write(takeObject(arg1));
}, arguments) };

module.exports.__wbg_end_f2122e0e4a84135e = function() { return logError(function (arg0) {
    getObject(arg0).end();
}, arguments) };

module.exports.__wbg_on_54d1a555a69f44dc = function() { return logError(function (arg0, arg1, arg2, arg3) {
    getObject(arg0).on(getStringFromWasm0(arg1, arg2), takeObject(arg3));
}, arguments) };

module.exports.__wbg_statusCode_bb2e6d21a82f8419 = function() { return logError(function (arg0) {
    const ret = getObject(arg0).statusCode;
    _assertNum(ret);
    return ret;
}, arguments) };

module.exports.__wbg_destroy_941799f0ef417338 = function() { return logError(function (arg0, arg1) {
    getObject(arg0).destroy(takeObject(arg1));
}, arguments) };

module.exports.__wbg_on_92dda420ca6f75d8 = function() { return logError(function (arg0, arg1, arg2, arg3) {
    getObject(arg0).on(getStringFromWasm0(arg1, arg2), takeObject(arg3));
}, arguments) };

module.exports.__wbindgen_cb_drop = function(arg0) {
    const obj = takeObject(arg0).original;
    if (obj.cnt-- == 1) {
        obj.a = 0;
        return true;
    }
    const ret = false;
    _assertBoolean(ret);
    return ret;
};

module.exports.__wbg_setInterval_edede8e2124cbb00 = function() { return handleError(function (arg0, arg1) {
    const ret = setInterval(getObject(arg0), arg1);
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_clearInterval_bd072ecb096d9775 = function() { return logError(function (arg0) {
    const ret = clearInterval(takeObject(arg0));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbindgen_is_undefined = function(arg0) {
    const ret = getObject(arg0) === undefined;
    _assertBoolean(ret);
    return ret;
};

module.exports.__wbg_new_b525de17f44a8943 = function() { return logError(function () {
    const ret = new Array();
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_push_49c286f04dd3bf59 = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg0).push(getObject(arg1));
    _assertNum(ret);
    return ret;
}, arguments) };

module.exports.__wbg_new_15d3966e9981a196 = function() { return logError(function (arg0, arg1) {
    const ret = new Error(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_newnoargs_2b8b6bd7753c76ba = function() { return logError(function (arg0, arg1) {
    const ret = new Function(getStringFromWasm0(arg0, arg1));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_call_95d1ea488d03e4e8 = function() { return handleError(function (arg0, arg1) {
    const ret = getObject(arg0).call(getObject(arg1));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_call_9495de66fdbe016b = function() { return handleError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).call(getObject(arg1), getObject(arg2));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_new_f9876326328f45ed = function() { return logError(function () {
    const ret = new Object();
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_new_9d3a9ce4282a18a8 = function() { return logError(function (arg0, arg1) {
    try {
        var state0 = {a: arg0, b: arg1};
        var cb0 = (arg0, arg1) => {
            const a = state0.a;
            state0.a = 0;
            try {
                return __wbg_adapter_169(a, state0.b, arg0, arg1);
            } finally {
                state0.a = a;
            }
        };
        const ret = new Promise(cb0);
        return addHeapObject(ret);
    } finally {
        state0.a = state0.b = 0;
    }
}, arguments) };

module.exports.__wbg_resolve_fd40f858d9db1a04 = function() { return logError(function (arg0) {
    const ret = Promise.resolve(getObject(arg0));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_then_ec5db6d509eb475f = function() { return logError(function (arg0, arg1) {
    const ret = getObject(arg0).then(getObject(arg1));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_then_f753623316e2873a = function() { return logError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).then(getObject(arg1), getObject(arg2));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_globalThis_87cbb8506fecf3a9 = function() { return handleError(function () {
    const ret = globalThis.globalThis;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_self_e7c1f827057f6584 = function() { return handleError(function () {
    const ret = self.self;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_window_a09ec664e14b1b81 = function() { return handleError(function () {
    const ret = window.window;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_global_c85a9259e621f3db = function() { return handleError(function () {
    const ret = global.global;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_new_537b7341ce90bb31 = function() { return logError(function (arg0) {
    const ret = new Uint8Array(getObject(arg0));
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_newwithlength_b56c882b57805732 = function() { return logError(function (arg0) {
    const ret = new Uint8Array(arg0 >>> 0);
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_subarray_7526649b91a252a6 = function() { return logError(function (arg0, arg1, arg2) {
    const ret = getObject(arg0).subarray(arg1 >>> 0, arg2 >>> 0);
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbg_length_27a2afe8ab42b09f = function() { return logError(function (arg0) {
    const ret = getObject(arg0).length;
    _assertNum(ret);
    return ret;
}, arguments) };

module.exports.__wbg_set_17499e8aa4003ebd = function() { return logError(function (arg0, arg1, arg2) {
    getObject(arg0).set(getObject(arg1), arg2 >>> 0);
}, arguments) };

module.exports.__wbg_set_6aa458a4ebdb65cb = function() { return handleError(function (arg0, arg1, arg2) {
    const ret = Reflect.set(getObject(arg0), getObject(arg1), getObject(arg2));
    _assertBoolean(ret);
    return ret;
}, arguments) };

module.exports.__wbindgen_is_function = function(arg0) {
    const ret = typeof(getObject(arg0)) === 'function';
    _assertBoolean(ret);
    return ret;
};

module.exports.__wbindgen_object_drop_ref = function(arg0) {
    takeObject(arg0);
};

module.exports.__wbg_buffer_cf65c07de34b9a08 = function() { return logError(function (arg0) {
    const ret = getObject(arg0).buffer;
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbindgen_debug_string = function(arg0, arg1) {
    const ret = debugString(getObject(arg1));
    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    getInt32Memory0()[arg0 / 4 + 1] = len0;
    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
};

module.exports.__wbindgen_throw = function(arg0, arg1) {
    throw new Error(getStringFromWasm0(arg0, arg1));
};

module.exports.__wbindgen_memory = function() {
    const ret = wasm.memory;
    return addHeapObject(ret);
};

module.exports.__wbindgen_closure_wrapper919 = function() { return logError(function (arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 34, __wbg_adapter_28);
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbindgen_closure_wrapper921 = function() { return logError(function (arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 36, __wbg_adapter_31);
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbindgen_closure_wrapper1837 = function() { return logError(function (arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 134, __wbg_adapter_34);
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbindgen_closure_wrapper1839 = function() { return logError(function (arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 136, __wbg_adapter_37);
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbindgen_closure_wrapper2103 = function() { return logError(function (arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 166, __wbg_adapter_40);
    return addHeapObject(ret);
}, arguments) };

module.exports.__wbindgen_closure_wrapper2347 = function() { return logError(function (arg0, arg1, arg2) {
    const ret = makeMutClosure(arg0, arg1, 189, __wbg_adapter_43);
    return addHeapObject(ret);
}, arguments) };

const path = require('path').join(__dirname, 'cursor_core_bg.wasm');
const bytes = require('fs').readFileSync(path);

const wasmModule = new WebAssembly.Module(bytes);
const wasmInstance = new WebAssembly.Instance(wasmModule, imports);
wasm = wasmInstance.exports;
module.exports.__wasm = wasm;

